/* Generated by wayland-scanner 1.16.0 */

#ifndef WAYFIRE_SHELL_CLIENT_PROTOCOL_H
#define WAYFIRE_SHELL_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_wayfire_shell The wayfire_shell protocol
 * @section page_ifaces_wayfire_shell Interfaces
 * - @subpage page_iface_zwf_shell_manager_v1 - DE integration
 * - @subpage page_iface_zwf_output_v1 - A wrapper for wl_output
 * - @subpage page_iface_zwf_wm_surface_v1 - Surface with a WM role
 */
struct wl_output;
struct wl_surface;
struct zwf_output_v1;
struct zwf_shell_manager_v1;
struct zwf_wm_surface_v1;

/**
 * @page page_iface_zwf_shell_manager_v1 zwf_shell_manager_v1
 * @section page_iface_zwf_shell_manager_v1_desc Description
 *
 * The purpose of this protocol is to enable the creation of different
 * desktop-interface windows like panels, backgrounds, docks,
 * lockscreens, etc. It also aims to allow the creation of full-blown
 * DEs using Wayfire.
 *
 * Note that in contrast to some other efforts to create a similar
 * protocol, such as wlr-layer-shell, this isn't a new "shell" for
 * giving a role to wl_surfaces. This protocol can be used with any
 * type of toplevel surface (xdg_toplevel, xdg_toplevel_v6, etc.)
 * to give them to the corresponding WM role.
 * @section page_iface_zwf_shell_manager_v1_api API
 * See @ref iface_zwf_shell_manager_v1.
 */
/**
 * @defgroup iface_zwf_shell_manager_v1 The zwf_shell_manager_v1 interface
 *
 * The purpose of this protocol is to enable the creation of different
 * desktop-interface windows like panels, backgrounds, docks,
 * lockscreens, etc. It also aims to allow the creation of full-blown
 * DEs using Wayfire.
 *
 * Note that in contrast to some other efforts to create a similar
 * protocol, such as wlr-layer-shell, this isn't a new "shell" for
 * giving a role to wl_surfaces. This protocol can be used with any
 * type of toplevel surface (xdg_toplevel, xdg_toplevel_v6, etc.)
 * to give them to the corresponding WM role.
 */
extern const struct wl_interface zwf_shell_manager_v1_interface;
/**
 * @page page_iface_zwf_output_v1 zwf_output_v1
 * @section page_iface_zwf_output_v1_desc Description
 *
 * Represents a single output.
 * Each output is managed independently from the others.
 * @section page_iface_zwf_output_v1_api API
 * See @ref iface_zwf_output_v1.
 */
/**
 * @defgroup iface_zwf_output_v1 The zwf_output_v1 interface
 *
 * Represents a single output.
 * Each output is managed independently from the others.
 */
extern const struct wl_interface zwf_output_v1_interface;
/**
 * @page page_iface_zwf_wm_surface_v1 zwf_wm_surface_v1
 * @section page_iface_zwf_wm_surface_v1_desc Description
 *
 * Represents a surface with a specific WM role.
 * It belongs to the output which it was created for.
 * @section page_iface_zwf_wm_surface_v1_api API
 * See @ref iface_zwf_wm_surface_v1.
 */
/**
 * @defgroup iface_zwf_wm_surface_v1 The zwf_wm_surface_v1 interface
 *
 * Represents a surface with a specific WM role.
 * It belongs to the output which it was created for.
 */
extern const struct wl_interface zwf_wm_surface_v1_interface;

#define ZWF_SHELL_MANAGER_V1_GET_WF_OUTPUT 0
#define ZWF_SHELL_MANAGER_V1_GET_WM_SURFACE 1


/**
 * @ingroup iface_zwf_shell_manager_v1
 */
#define ZWF_SHELL_MANAGER_V1_GET_WF_OUTPUT_SINCE_VERSION 1
/**
 * @ingroup iface_zwf_shell_manager_v1
 */
#define ZWF_SHELL_MANAGER_V1_GET_WM_SURFACE_SINCE_VERSION 1

/** @ingroup iface_zwf_shell_manager_v1 */
static inline void
zwf_shell_manager_v1_set_user_data(struct zwf_shell_manager_v1 *zwf_shell_manager_v1, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zwf_shell_manager_v1, user_data);
}

/** @ingroup iface_zwf_shell_manager_v1 */
static inline void *
zwf_shell_manager_v1_get_user_data(struct zwf_shell_manager_v1 *zwf_shell_manager_v1)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zwf_shell_manager_v1);
}

static inline uint32_t
zwf_shell_manager_v1_get_version(struct zwf_shell_manager_v1 *zwf_shell_manager_v1)
{
	return wl_proxy_get_version((struct wl_proxy *) zwf_shell_manager_v1);
}

/** @ingroup iface_zwf_shell_manager_v1 */
static inline void
zwf_shell_manager_v1_destroy(struct zwf_shell_manager_v1 *zwf_shell_manager_v1)
{
	wl_proxy_destroy((struct wl_proxy *) zwf_shell_manager_v1);
}

/**
 * @ingroup iface_zwf_shell_manager_v1
 */
static inline struct zwf_output_v1 *
zwf_shell_manager_v1_get_wf_output(struct zwf_shell_manager_v1 *zwf_shell_manager_v1, struct wl_output *output)
{
	struct wl_proxy *id;

	id = wl_proxy_marshal_constructor((struct wl_proxy *) zwf_shell_manager_v1,
			 ZWF_SHELL_MANAGER_V1_GET_WF_OUTPUT, &zwf_output_v1_interface, output, NULL);

	return (struct zwf_output_v1 *) id;
}

/**
 * @ingroup iface_zwf_shell_manager_v1
 *
 * Assign the given role to the given surface and add it to the
 * given output. A client can specify a null output, in which case
 * the compositor will assign the surface to the focused output,
 * if any such output.
 *
 * The role cannot be changed later, and neither can the surface be
 * moved to a different output, except by the compositor.
 */
static inline struct zwf_wm_surface_v1 *
zwf_shell_manager_v1_get_wm_surface(struct zwf_shell_manager_v1 *zwf_shell_manager_v1, struct wl_surface *surface, uint32_t role, struct wl_output *output)
{
	struct wl_proxy *id;

	id = wl_proxy_marshal_constructor((struct wl_proxy *) zwf_shell_manager_v1,
			 ZWF_SHELL_MANAGER_V1_GET_WM_SURFACE, &zwf_wm_surface_v1_interface, surface, role, output, NULL);

	return (struct zwf_wm_surface_v1 *) id;
}

/**
 * @ingroup iface_zwf_output_v1
 * @struct zwf_output_v1_listener
 */
struct zwf_output_v1_listener {
	/**
	 * Autohide/Show signal
	 *
	 * Panels are always rendered on top, even above fullscreen
	 * windows. If autohide is 1, the event indicates that the panels
	 * should hide itself, by for example unmapping or sliding outside
	 * of the output. If autohide is 0, this means that the reason for
	 * the last request with autohide == 1 is no longer valid, i.e the
	 * panels can show themselves.
	 *
	 * The output_hide_panels can be called multiple times with
	 * autohide = 1, and the panel should show itself only when it has
	 * received a matching number of events with autohide = 0
	 */
	void (*output_hide_panels)(void *data,
				   struct zwf_output_v1 *zwf_output_v1,
				   uint32_t autohide);
};

/**
 * @ingroup iface_zwf_output_v1
 */
static inline int
zwf_output_v1_add_listener(struct zwf_output_v1 *zwf_output_v1,
			   const struct zwf_output_v1_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) zwf_output_v1,
				     (void (**)(void)) listener, data);
}

#define ZWF_OUTPUT_V1_INHIBIT_OUTPUT 0
#define ZWF_OUTPUT_V1_INHIBIT_OUTPUT_DONE 1

/**
 * @ingroup iface_zwf_output_v1
 */
#define ZWF_OUTPUT_V1_OUTPUT_HIDE_PANELS_SINCE_VERSION 1

/**
 * @ingroup iface_zwf_output_v1
 */
#define ZWF_OUTPUT_V1_INHIBIT_OUTPUT_SINCE_VERSION 1
/**
 * @ingroup iface_zwf_output_v1
 */
#define ZWF_OUTPUT_V1_INHIBIT_OUTPUT_DONE_SINCE_VERSION 1

/** @ingroup iface_zwf_output_v1 */
static inline void
zwf_output_v1_set_user_data(struct zwf_output_v1 *zwf_output_v1, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zwf_output_v1, user_data);
}

/** @ingroup iface_zwf_output_v1 */
static inline void *
zwf_output_v1_get_user_data(struct zwf_output_v1 *zwf_output_v1)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zwf_output_v1);
}

static inline uint32_t
zwf_output_v1_get_version(struct zwf_output_v1 *zwf_output_v1)
{
	return wl_proxy_get_version((struct wl_proxy *) zwf_output_v1);
}

/** @ingroup iface_zwf_output_v1 */
static inline void
zwf_output_v1_destroy(struct zwf_output_v1 *zwf_output_v1)
{
	wl_proxy_destroy((struct wl_proxy *) zwf_output_v1);
}

/**
 * @ingroup iface_zwf_output_v1
 *
 * Request the compositor to not render the output, so
 * the output usually is cleared to black color.
 * To enable output rendering again, call inhibit_output_done
 */
static inline void
zwf_output_v1_inhibit_output(struct zwf_output_v1 *zwf_output_v1)
{
	wl_proxy_marshal((struct wl_proxy *) zwf_output_v1,
			 ZWF_OUTPUT_V1_INHIBIT_OUTPUT);
}

/**
 * @ingroup iface_zwf_output_v1
 *
 * Stop inhibiting the output. This must be called as many times
 * as inhibit_output was called to actually uninhibit rendering.
 *
 * The inhibit/inhibit_done requests can be called multiple times,
 * even from different apps, so don't assume that a call to
 * inhibit_done would always mean actually starting the rendering process.
 */
static inline void
zwf_output_v1_inhibit_output_done(struct zwf_output_v1 *zwf_output_v1)
{
	wl_proxy_marshal((struct wl_proxy *) zwf_output_v1,
			 ZWF_OUTPUT_V1_INHIBIT_OUTPUT_DONE);
}

#ifndef ZWF_WM_SURFACE_V1_ROLE_ENUM
#define ZWF_WM_SURFACE_V1_ROLE_ENUM
enum zwf_wm_surface_v1_role {
	ZWF_WM_SURFACE_V1_ROLE_BACKGROUND = 1,
	ZWF_WM_SURFACE_V1_ROLE_BOTTOM = 2,
	ZWF_WM_SURFACE_V1_ROLE_PANEL = 3,
	ZWF_WM_SURFACE_V1_ROLE_OVERLAY = 4,
};
#endif /* ZWF_WM_SURFACE_V1_ROLE_ENUM */

#ifndef ZWF_WM_SURFACE_V1_ANCHOR_EDGE_ENUM
#define ZWF_WM_SURFACE_V1_ANCHOR_EDGE_ENUM
enum zwf_wm_surface_v1_anchor_edge {
	ZWF_WM_SURFACE_V1_ANCHOR_EDGE_TOP = 1,
	ZWF_WM_SURFACE_V1_ANCHOR_EDGE_BOTTOM = 2,
	ZWF_WM_SURFACE_V1_ANCHOR_EDGE_LEFT = 4,
	ZWF_WM_SURFACE_V1_ANCHOR_EDGE_RIGHT = 8,
};
#endif /* ZWF_WM_SURFACE_V1_ANCHOR_EDGE_ENUM */

#ifndef ZWF_WM_SURFACE_V1_KEYBOARD_FOCUS_MODE_ENUM
#define ZWF_WM_SURFACE_V1_KEYBOARD_FOCUS_MODE_ENUM
enum zwf_wm_surface_v1_keyboard_focus_mode {
	ZWF_WM_SURFACE_V1_KEYBOARD_FOCUS_MODE_NO_FOCUS = 0,
	ZWF_WM_SURFACE_V1_KEYBOARD_FOCUS_MODE_CLICK_TO_FOCUS = 1,
	ZWF_WM_SURFACE_V1_KEYBOARD_FOCUS_MODE_EXCLUSIVE_FOCUS = 2,
};
#endif /* ZWF_WM_SURFACE_V1_KEYBOARD_FOCUS_MODE_ENUM */

#define ZWF_WM_SURFACE_V1_CONFIGURE 0
#define ZWF_WM_SURFACE_V1_SET_ANCHOR 1
#define ZWF_WM_SURFACE_V1_SET_MARGIN 2
#define ZWF_WM_SURFACE_V1_SET_KEYBOARD_MODE 3
#define ZWF_WM_SURFACE_V1_SET_EXCLUSIVE_ZONE 4


/**
 * @ingroup iface_zwf_wm_surface_v1
 */
#define ZWF_WM_SURFACE_V1_CONFIGURE_SINCE_VERSION 1
/**
 * @ingroup iface_zwf_wm_surface_v1
 */
#define ZWF_WM_SURFACE_V1_SET_ANCHOR_SINCE_VERSION 1
/**
 * @ingroup iface_zwf_wm_surface_v1
 */
#define ZWF_WM_SURFACE_V1_SET_MARGIN_SINCE_VERSION 1
/**
 * @ingroup iface_zwf_wm_surface_v1
 */
#define ZWF_WM_SURFACE_V1_SET_KEYBOARD_MODE_SINCE_VERSION 1
/**
 * @ingroup iface_zwf_wm_surface_v1
 */
#define ZWF_WM_SURFACE_V1_SET_EXCLUSIVE_ZONE_SINCE_VERSION 1

/** @ingroup iface_zwf_wm_surface_v1 */
static inline void
zwf_wm_surface_v1_set_user_data(struct zwf_wm_surface_v1 *zwf_wm_surface_v1, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zwf_wm_surface_v1, user_data);
}

/** @ingroup iface_zwf_wm_surface_v1 */
static inline void *
zwf_wm_surface_v1_get_user_data(struct zwf_wm_surface_v1 *zwf_wm_surface_v1)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zwf_wm_surface_v1);
}

static inline uint32_t
zwf_wm_surface_v1_get_version(struct zwf_wm_surface_v1 *zwf_wm_surface_v1)
{
	return wl_proxy_get_version((struct wl_proxy *) zwf_wm_surface_v1);
}

/** @ingroup iface_zwf_wm_surface_v1 */
static inline void
zwf_wm_surface_v1_destroy(struct zwf_wm_surface_v1 *zwf_wm_surface_v1)
{
	wl_proxy_destroy((struct wl_proxy *) zwf_wm_surface_v1);
}

/**
 * @ingroup iface_zwf_wm_surface_v1
 */
static inline void
zwf_wm_surface_v1_configure(struct zwf_wm_surface_v1 *zwf_wm_surface_v1, int32_t x, int32_t y)
{
	wl_proxy_marshal((struct wl_proxy *) zwf_wm_surface_v1,
			 ZWF_WM_SURFACE_V1_CONFIGURE, x, y);
}

/**
 * @ingroup iface_zwf_wm_surface_v1
 *
 * Sets the position on the screen where the compositor should
 * position the view. Can be reset by specifying anchor 0. If not
 * set, the compositor will assume manual positioning via the
 * configure request.
 *
 * If one anchor edge is provided, the wm surface is "stuck" to
 * that edge.
 * If two anchor edges are provided, the wm surface is considered
 * anchored to the corner of the screen between them.
 *
 * Any other anchor edge configuration is considered invalid.
 */
static inline void
zwf_wm_surface_v1_set_anchor(struct zwf_wm_surface_v1 *zwf_wm_surface_v1, uint32_t anchors)
{
	wl_proxy_marshal((struct wl_proxy *) zwf_wm_surface_v1,
			 ZWF_WM_SURFACE_V1_SET_ANCHOR, anchors);
}

/**
 * @ingroup iface_zwf_wm_surface_v1
 *
 * Set the offset from the anchored edges to the wm surface. This
 * is an alternative to the configure request. Using both will
 * result in undefined results.
 *
 * Margin has effect only for edges the wm surface is anchored to.
 */
static inline void
zwf_wm_surface_v1_set_margin(struct zwf_wm_surface_v1 *zwf_wm_surface_v1, int32_t top, int32_t bottom, int32_t left, int32_t right)
{
	wl_proxy_marshal((struct wl_proxy *) zwf_wm_surface_v1,
			 ZWF_WM_SURFACE_V1_SET_MARGIN, top, bottom, left, right);
}

/**
 * @ingroup iface_zwf_wm_surface_v1
 *
 * Sets how the wm surface will interact with keyboard focus.
 * Setting no_focus means that the surface will never receive
 * keyboard focus, click_to_focus means normal focus semantics (i.e
 * what you expect from "normal" windows), and exclusive focus means
 * that no other window can get keyboard focus.
 */
static inline void
zwf_wm_surface_v1_set_keyboard_mode(struct zwf_wm_surface_v1 *zwf_wm_surface_v1, uint32_t mode)
{
	wl_proxy_marshal((struct wl_proxy *) zwf_wm_surface_v1,
			 ZWF_WM_SURFACE_V1_SET_KEYBOARD_MODE, mode);
}

/**
 * @ingroup iface_zwf_wm_surface_v1
 *
 * Request the compositor to reserve the given amount of pixels
 * for the wm surface(like STRUTS in X11). This has effect only
 * if the surface is anchored to a single edge. Margin doesn't
 * affect exclusive zone in any way.
 */
static inline void
zwf_wm_surface_v1_set_exclusive_zone(struct zwf_wm_surface_v1 *zwf_wm_surface_v1, uint32_t size)
{
	wl_proxy_marshal((struct wl_proxy *) zwf_wm_surface_v1,
			 ZWF_WM_SURFACE_V1_SET_EXCLUSIVE_ZONE, size);
}

#ifdef  __cplusplus
}
#endif

#endif
